-- @titel       MotorBrakeforceCorrection Script for FarmingSimulator 2022
-- @author      s4t4n aka SbSh
-- @version     v1.0.0.0 Release Modhub
-- @version		v1.0.0.1 Small Changes(FS22 1.2.0.2)
-- @date        23/12/2022
-- @info        MotorBrakeforceCorrection Script for FarmingSimulator 2022
-- changed		app to pre 23.12.2022 SbSh(s4t4n)
-- changelog	adaptation to FS22_realismAddon_gearbox from modelleicher
--				and other script mods were in conflict
local modName = g_currentModName
-- @category Specializations

MotorBrakeforceCorrection = {}
-- MotorBrakeforceCorrection.SPEC_TABLE_NAME = "spec_"..modName..".lowBrakeForceScale"
-- MotorBrakeforceCorrection.spec_motorized = "spec_"..modName..".motor"
function MotorBrakeforceCorrection.prerequisitesPresent(specializations)
	return true
end

function MotorBrakeforceCorrection:onUpdate(dt)
	-- local spec = self[MotorBrakeforceCorrection.spec_motorized]
	-- print("BF")
	-- print("BF old:" ..tostring(self.spec_motorized.motor.lowBrakeForceScale));
	if self.MotorBrakeforceCorrection == nil then
		self.MotorBrakeforceCorrection = true;
		-- echo("BF");
		if self.spec_motorized ~= nil then
			if self.spec_motorized.motor ~= nil then
				-- if self.spec_motorized.motor.lowBrakeForceScale ~= nil and self.spec_motorized.motor.lastManualShifterActive == false and self.spec_motorized.motor.groupType == 1 and self.spec_motorized.motor.gearType == 1 and self.spec_motorized.motor.forwardGears then
				if self.spec_motorized.motor.lowBrakeForceScale ~= nil and self.spec_motorized.motor.lastManualShifterActive == false and self.spec_motorized.motor.groupType == 1 and self.spec_motorized.motor.gearType == 1 then
					-- 0.45 = -55% BrakeForce
					self.spec_motorized.motor.lowBrakeForceScale = self.spec_motorized.motor.lowBrakeForceScale * 2.9; -- 0.10 is default X 2.9 = 0.29 ! CVTs
					self.spec_motorized.motor.lowBrakeForceSpeedLimit = 0.000001
					
					-- print("BF lastManualShifterActive:" ..tostring(self.spec_motorized.motor.lastManualShifterActive));
					-- print("BF groupType:" ..tostring(self.spec_motorized.motor.groupType));
					-- print("BF gearType:" ..tostring(self.spec_motorized.motor.gearType));
					-- print("BF forwardGears:" ..tostring(self.spec_motorized.motor.forwardGears));
					-- print("BF lowBrakeForceScale:" ..tostring(self.spec_motorized.motor.lowBrakeForceScale));
					-- print("BF brakeForce:" ..tostring(self.spec_motorized.motor.brakeForce));
					-- print("BF lowBrakeForceSpeedLimit:" ..tostring(self.spec_motorized.motor.lowBrakeForceSpeedLimit));
				else
					self.spec_motorized.motor.lowBrakeForceScale = self.spec_motorized.motor.lowBrakeForceScale * 0.2; -- 0.10 is default X 0.2 = 0.02 ! MANUAL SHIFT
					-- print("BF lowBrakeForceSpeedLimit:" ..tostring(self.spec_motorized.motor.lowBrakeForceSpeedLimit));
					-- self.spec_motorized.motor.lowBrakeForceSpeedLimit = 0.0002777777777777778 - original
					self.spec_motorized.motor.lowBrakeForceSpeedLimit = 0.000001
				end;
			end;
		end;
	end;
end;

Drivable.onUpdate  = Utils.prependedFunction(Drivable.onUpdate, MotorBrakeforceCorrection.onUpdate);

